#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum RangePaddingConfiguration {
    #[serde(rename = "PAD_START")]
    PadStart,
    #[serde(rename = "PAD_END")]
    PadEnd,
    #[serde(rename = "PAD_START_AND_END")]
    PadStartAndEnd,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl RangePaddingConfiguration {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            RangePaddingConfiguration::PadStart => "PAD_START",
            RangePaddingConfiguration::PadEnd => "PAD_END",
            RangePaddingConfiguration::PadStartAndEnd => "PAD_START_AND_END",
            RangePaddingConfiguration::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for RangePaddingConfiguration {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for RangePaddingConfiguration {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for RangePaddingConfiguration {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<RangePaddingConfiguration, conjure_object::plain::ParseEnumError> {
        match v {
            "PAD_START" => Ok(RangePaddingConfiguration::PadStart),
            "PAD_END" => Ok(RangePaddingConfiguration::PadEnd),
            "PAD_START_AND_END" => Ok(RangePaddingConfiguration::PadStartAndEnd),
            v => v.parse().map(|v| RangePaddingConfiguration::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for RangePaddingConfiguration {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<RangePaddingConfiguration, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the RangePaddingConfiguration enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
